export * from '@storybook/vue3';
import { StorybookConfig as StorybookConfig$1 } from '@storybook/types';
import { FrameworkOptions } from '@storybook/vue3-vite';
import { StorybookConfigVite, BuilderOptions as BuilderOptions$1 } from '@storybook/builder-vite';

type FrameworkName = '@storybook-vue/nuxt'
type BuilderName = '@storybook/builder-vite'

type BuilderOptions = BuilderOptions$1 & {
  outputDir?: string
}

type StorybookConfigFramework = {
  framework:
    | FrameworkName
    | { name: FrameworkName; options: FrameworkOptions }
  core?: Omit<StorybookConfig$1['core'], 'builder'> & {
    builder?:
      | BuilderName
      | {
          name: BuilderName
          options?: BuilderOptions
        }
  }
}

/**
 * The interface for Storybook configuration in `main.ts` files.
 */
type StorybookConfig = Omit<
  StorybookConfig$1,
  keyof StorybookConfigVite | keyof StorybookConfigFramework
> &
  StorybookConfigVite &
  StorybookConfigFramework

export type { StorybookConfig };
